Imports System.IO
Imports ChartTester.ChartTesterDts

Public Class frmChartTester

   Private _DataFile As New FileInfo("..\..\ChartTesterDts.DataSet.xml")

   Private Sub frmParentChild_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
      Location = Screen.PrimaryScreen.WorkingArea.Location
      Reload()
   End Sub

   Private Sub MenuStrip1_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
         Handles SaveToolStripMenuItem.Click, ReloadToolStripMenuItem.Click, btDataBind.Click
      Select Case True
         Case Sender Is SaveToolStripMenuItem
            Save()
         Case Sender Is ReloadToolStripMenuItem
            Reload()
         Case Sender Is btDataBind
            Chart1.DataBind()
      End Select
   End Sub


   Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) _
         Handles Me.FormClosing
      If e.Cancel Then Return
      Dim frm = DirectCast(sender, Form)
      If Not ChartTesterDts.HasChanges Then Return
      Select Case MessageBox.Show(frm, "nderungen speichern?", "Das Ende ist nahe", MessageBoxButtons.YesNoCancel)
         Case Windows.Forms.DialogResult.Yes
            Save()
         Case Windows.Forms.DialogResult.No
            Return 'nix tun
         Case Windows.Forms.DialogResult.Cancel
            e.Cancel = True
            Return
      End Select
      e.Cancel = False
   End Sub

   Private Sub Save()
      'Validate berprft alle aktuellen Control-Eingaben, und **bernimmt sie in die Datasource**. Letzteres ist wichtig, da ansonsten der User berrascht wird, weil seine letzte Eingabe gecancelt wrde.
      'AcceptChanges markiert alle Datenstze als bereinstimmend mit der "Datenbank" - wichtig fr den Dataset.HasChanges-Test im FormClosing
      Me.Validate()
      Me.ChartTesterDts.WriteXml(_DataFile.FullName)
      ChartTesterDts.AcceptChanges()
      Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub Reload()
      Me.ChartTesterDts.Clear()
      If _DataFile.Exists() Then
         Me.ChartTesterDts.ReadXml(_DataFile.FullName)
      Else
         MessageBox.Show(String.Concat( _
            "Leider (noch) kein DatenFile vorhanden", Lf, _
            "Sie knnen aber trotzdem fortfahren, und eines anlegen."))
      End If
      ChartTesterDts.AcceptChanges()
   End Sub

End Class